#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <event.h>
#include <signal.h>

#define FIFO_PIPE      "/tmp/fifo.remotedigits"
#define MAX_BUF_SIZE    2

/* compile with cc -levent */

int socket;
int selecter = 0;
char zahl[2] = { 0 };

void reset_vars() {
	memset( zahl, 0, strlen( zahl ) );
	selecter = 0;
}

void sysexec( char *digit ) {
	char string[20];

	strcpy( string, "/usr/bin/chstream ");
	strcat( string, digit );

	printf( "%s\n", string );
	system( string );
}

void fifo_read(int fd, short event, void *arg) {
	char buf[ MAX_BUF_SIZE ];
	int len;
	struct event *ev = arg;
	struct timeval timeout;

	fprintf( stderr, "fifo_read called with fd: %d, event: %d, arg: %p\n", fd, event, arg );

	len = read( fd, buf, sizeof( buf ) - 1 );
	if( len == -1 ) {
		/* Here we have a timeout, so we can print out the numer*/
		sysexec( zahl );

		reset_vars();
// 		perror( "read" );
		event_add( ev, NULL );
		return;
	} else if( len == 0 ) {
		fprintf( stderr, "Connection closed\n" );
		return;
	}

	buf[ len ] = '\0';
// 	fprintf( stdout, "Read: %s, 1st Char: %d\n", buf, buf[0] );

	if( ( buf[0] >= 48 ) && ( buf[0] <= 57 ) ) {
		if( selecter == 1 ) {
			/* We have the second number, so we can print out the number*/
			strcat( zahl, buf );
			sysexec( zahl );
			reset_vars();
			event_add( ev, NULL );
			return;
		}

		if( buf[0] == 48 ) {
			/* Numbers can't start with 0
			   reset everything and start from scratch
			*/
			reset_vars();
			event_add( ev, NULL );
			return;
		}
		zahl[0] = buf[0];
		selecter++;

		timeout.tv_sec = 1;
		timeout.tv_usec = 0;
		/* Reschedule this event with timeout*/
		event_add( ev, &timeout );
	} else {
		/* not a valid number reschedule event */
		event_add( ev, NULL );
	}

	return;
}

void DoSigTerm( int sig ) {
	close( socket );
	(void) unlink( FIFO_PIPE );
	signal( sig, SIG_DFL );
	raise( sig );
}

int main( int argc, char *argv[] ) {
	struct event evfifo;
	struct stat st;

	if( lstat( FIFO_PIPE, &st ) == 0 ) {
		if ((st.st_mode & S_IFMT) == S_IFREG) {
			errno = EEXIST;
			perror("lstat");
			exit (1);
		}
	}

	unlink( FIFO_PIPE );
	if( mkfifo( FIFO_PIPE, 0600 ) == -1 ) {
		perror( "mkfifo" );
		exit( 1 );
	}

	/* Linux pipes are broken, we need O_RDWR instead of O_RDONLY */
	socket = open( FIFO_PIPE, O_RDWR | O_NONBLOCK, 0 );
	if( socket == -1 ) {
		perror("open");
		exit( 1 );
	}

	fprintf( stderr, "Write data to %s\n", FIFO_PIPE );

	signal( SIGTERM, DoSigTerm );

	/* Initalize the event library */
	event_init();

	/* Initalize one event */
	event_set( &evfifo, socket, EV_READ, fifo_read, &evfifo );

	/* Add it to the active events, without a timeout */
	event_add( &evfifo, NULL );

	event_dispatch();

	close( socket );
	unlink( FIFO_PIPE );
	return (0);
}
